//+------------------------------------------------------------------+
//|                                          T101_orest_graph_v1.mq4 |
//|                                                            OlegV |
//|                         Copyright  2007, Vorobev Software Corp. |
//+------------------------------------------------------------------+
#property copyright "OlegV"
#property link      "Copyright  2007, Vorobev Software Corp."

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Green
#property indicator_color2 Green
#property indicator_color3 Green
#property indicator_color4 Green
#property indicator_color5 Green
#property indicator_color6 Green
#property indicator_color7 Green
#property indicator_color8 Green

extern string c1         = "1 -  buy, -1 -  sell";
extern int    NumOper    = 1;
extern int    Shift      = 12;
extern string Pairs      = "GBPUSD;EURGBP;GBPCHF;CHFJPY;AUDJPY;EURJPY;USDCHF";
extern int    Limit      = 5000;
extern string NameShort  = "H1";

double Pairs1[], Pairs2[], Pairs3[], Pairs4[], Pairs5[], Pairs6[], Pairs7[], Pairs8[];
string PairsName[8];
int    NumPairs = 0;
bool   first;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   ReadSymbol();
   SetIndexBuffer(0,Pairs1);
   SetIndexBuffer(1,Pairs2);
   SetIndexBuffer(2,Pairs3);
   SetIndexBuffer(3,Pairs4);
   SetIndexBuffer(4,Pairs5);
   SetIndexBuffer(5,Pairs6);
   SetIndexBuffer(6,Pairs7);
   SetIndexBuffer(7,Pairs8);
   if (NumPairs > 0) {
      SetIndexStyle(0,DRAW_LINE);
      SetIndexLabel(0, PairsName[0]);
   } else {
      SetIndexStyle(0,DRAW_NONE);
   }
   if (NumPairs > 1) {
      SetIndexStyle(1,DRAW_LINE);
      SetIndexLabel(1, PairsName[1]);
   } else {
      SetIndexStyle(1,DRAW_NONE);
   }
   if (NumPairs > 2) {
      SetIndexStyle(2,DRAW_LINE);
      SetIndexLabel(2, PairsName[2]);
   } else {
      SetIndexStyle(2,DRAW_NONE);
   }
   if (NumPairs > 3) {
      SetIndexStyle(3,DRAW_LINE);
      SetIndexLabel(3, PairsName[3]);
   } else {
      SetIndexStyle(3,DRAW_NONE);
   }
   if (NumPairs > 4) {
      SetIndexStyle(4,DRAW_LINE);
      SetIndexLabel(4, PairsName[4]);
   } else {
      SetIndexStyle(4,DRAW_NONE);
   }
   if (NumPairs > 5) {
      SetIndexStyle(5,DRAW_LINE);
      SetIndexLabel(5, PairsName[5]);
   } else {
      SetIndexStyle(5,DRAW_NONE);
   }
   if (NumPairs > 6) {
      SetIndexStyle(6,DRAW_LINE);
      SetIndexLabel(6, PairsName[6]);
   } else {
      SetIndexStyle(6,DRAW_NONE);
   }
   if (NumPairs > 7) {
      SetIndexStyle(7,DRAW_LINE);
      SetIndexLabel(7, PairsName[7]);
   } else {
      SetIndexStyle(7,DRAW_NONE);
   }
   IndicatorShortName(NameShort);
   first = true;
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int lim, i, j;
   if (first) {
      lim = Limit;
      first = false;
   } else {
      lim = Shift;
   }
   for(i = lim; i >= 0; i--) {
      for(j = 0; j < NumPairs; j++) {
         if (NumOper == 1) {
            if (MarketInfo(PairsName[j], MODE_DIGITS) == 4) {
               if (j == 0) {
                  Pairs1[i] = (iClose(PairsName[j], 0, i) - iClose(PairsName[j], 0, i + Shift)) * 10000;
               }
               if (j == 1) {
                  Pairs2[i] = (iClose(PairsName[j], 0, i) - iClose(PairsName[j], 0, i + Shift)) * 10000;
               }
               if (j == 2) {
                  Pairs3[i] = (iClose(PairsName[j], 0, i) - iClose(PairsName[j], 0, i + Shift)) * 10000;
               }
               if (j == 3) {
                  Pairs4[i] = (iClose(PairsName[j], 0, i) - iClose(PairsName[j], 0, i + Shift)) * 10000;
               }
               if (j == 4) {
                  Pairs5[i] = (iClose(PairsName[j], 0, i) - iClose(PairsName[j], 0, i + Shift)) * 10000;
               }
               if (j == 5) {
                  Pairs6[i] = (iClose(PairsName[j], 0, i) - iClose(PairsName[j], 0, i + Shift)) * 10000;
               }
               if (j == 6) {
                  Pairs7[i] = (iClose(PairsName[j], 0, i) - iClose(PairsName[j], 0, i + Shift)) * 10000;
               }
               if (j == 7) {
                  Pairs8[i] = (iClose(PairsName[j], 0, i) - iClose(PairsName[j], 0, i + Shift)) * 10000;
               }
            } else {
               if (j == 0) {
                  Pairs1[i] = (iClose(PairsName[j], 0, i) - iClose(PairsName[j], 0, i + Shift)) * 100;
               }
               if (j == 1) {
                  Pairs2[i] = (iClose(PairsName[j], 0, i) - iClose(PairsName[j], 0, i + Shift)) * 100;
               }
               if (j == 2) {
                  Pairs3[i] = (iClose(PairsName[j], 0, i) - iClose(PairsName[j], 0, i + Shift)) * 100;
               }
               if (j == 3) {
                  Pairs4[i] = (iClose(PairsName[j], 0, i) - iClose(PairsName[j], 0, i + Shift)) * 100;
               }
               if (j == 4) {
                  Pairs5[i] = (iClose(PairsName[j], 0, i) - iClose(PairsName[j], 0, i + Shift)) * 100;
               }
               if (j == 5) {
                  Pairs6[i] = (iClose(PairsName[j], 0, i) - iClose(PairsName[j], 0, i + Shift)) * 100;
               }
               if (j == 6) {
                  Pairs7[i] = (iClose(PairsName[j], 0, i) - iClose(PairsName[j], 0, i + Shift)) * 100;
               }
               if (j == 7) {
                  Pairs8[i] = (iClose(PairsName[j], 0, i) - iClose(PairsName[j], 0, i + Shift)) * 100;
               }
            }
         }
         if (NumOper == -1) {
            if (MarketInfo(PairsName[j], MODE_DIGITS) == 4) {
               if (j == 0) {
                  Pairs1[i] = (iClose(PairsName[j], 0, i + Shift) - iClose(PairsName[j], 0, i)) * 10000;
               }
               if (j == 1) {
                  Pairs2[i] = (iClose(PairsName[j], 0, i + Shift) - iClose(PairsName[j], 0, i)) * 10000;
               }
               if (j == 2) {
                  Pairs3[i] = (iClose(PairsName[j], 0, i + Shift) - iClose(PairsName[j], 0, i)) * 10000;
               }
               if (j == 3) {
                  Pairs4[i] = (iClose(PairsName[j], 0, i + Shift) - iClose(PairsName[j], 0, i)) * 10000;
               }
               if (j == 4) {
                  Pairs5[i] = (iClose(PairsName[j], 0, i + Shift) - iClose(PairsName[j], 0, i)) * 10000;
               }
               if (j == 5) {
                  Pairs6[i] = (iClose(PairsName[j], 0, i + Shift) - iClose(PairsName[j], 0, i)) * 10000;
               }
               if (j == 6) {
                  Pairs7[i] = (iClose(PairsName[j], 0, i + Shift) - iClose(PairsName[j], 0, i)) * 10000;
               }
               if (j == 7) {
                  Pairs8[i] = (iClose(PairsName[j], 0, i + Shift) - iClose(PairsName[j], 0, i)) * 10000;
               }
            } else {
               if (j == 0) {
                  Pairs1[i] = (iClose(PairsName[j], 0, i + Shift) - iClose(PairsName[j], 0, i)) * 100;
               }
               if (j == 1) {
                  Pairs2[i] = (iClose(PairsName[j], 0, i + Shift) - iClose(PairsName[j], 0, i)) * 100;
               }
               if (j == 2) {
                  Pairs3[i] = (iClose(PairsName[j], 0, i + Shift) - iClose(PairsName[j], 0, i)) * 100;
               }
               if (j == 3) {
                  Pairs4[i] = (iClose(PairsName[j], 0, i + Shift) - iClose(PairsName[j], 0, i)) * 100;
               }
               if (j == 4) {
                  Pairs5[i] = (iClose(PairsName[j], 0, i + Shift) - iClose(PairsName[j], 0, i)) * 100;
               }
               if (j == 5) {
                  Pairs6[i] = (iClose(PairsName[j], 0, i + Shift) - iClose(PairsName[j], 0, i)) * 100;
               }
               if (j == 6) {
                  Pairs7[i] = (iClose(PairsName[j], 0, i + Shift) - iClose(PairsName[j], 0, i)) * 100;
               }
               if (j == 7) {
                  Pairs8[i] = (iClose(PairsName[j], 0, i + Shift) - iClose(PairsName[j], 0, i)) * 100;
               }
            }
         }
      }
   }
   return(0);
}

void ReadSymbol() {
   int    np;
   string st, tmp = Pairs;
   while (StringLen(tmp)>0) {
      np = StringFind(tmp, ";");
      if (np < 0) {
         st = tmp;
         tmp = "";
      } else {
         st = StringSubstr(tmp, 0, np);
         tmp = StringSubstr(tmp, np + 1);
      }
      PairsName[NumPairs]=st;
      NumPairs++;
   }
}
//+------------------------------------------------------------------+